package com.glarimy.jws;

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;

public class LibraryProxy implements Library {
	Socket connection = null;
	ObjectInputStream ois = null;
	ObjectOutputStream oos = null;
	PDU request = null;
	PDU response = null;

	@Override
	public void add(Book book) throws LibraryException {
		try {
			connection = new Socket("localhost", 1234);
			oos = new ObjectOutputStream(connection.getOutputStream());
			request = new PDU();
			request.setHeader(Protocol.REQ_ADD);
			request.setPayload(book);
			oos.writeObject(request);
			ois = new ObjectInputStream(connection.getInputStream());
			response = (PDU) ois.readObject();
			oos.close();
			ois.close();
			connection.close();
			if (response.getHeader() != Protocol.RESP_ADD)
				((LibraryException) response.getPayload()).printStackTrace();
		} catch (Exception e) {
			throw new LibraryException(e);
		}
	}

	@Override
	public Book search(int isbn) throws LibraryException {
		try {
			connection = new Socket("localhost", 1234);
			oos = new ObjectOutputStream(connection.getOutputStream());
			request = new PDU();
			request.setHeader(Protocol.REQ_SEARCH);
			request.setPayload(isbn);
			oos.writeObject(request);
			ois = new ObjectInputStream(connection.getInputStream());
			response = (PDU) ois.readObject();
			oos.close();
			ois.close();
			connection.close();
			if (response.getHeader() != Protocol.RESP_SEARCH)
				throw (LibraryException) response.getPayload();
			else
				return (Book) response.getPayload();
		} catch (Exception e) {
			throw new LibraryException(e);
		}
	}
}