package com.glarimy.jws;

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;

public class Client {
	public static void main(String[] args) throws Exception {
		Book xml = new Book();
		xml.setIsbn(12345);
		xml.setPrice(23.45);
		xml.setTitle("XML");
		xml.setReference(false);

		Book java = new Book();
		java.setIsbn(45098);
		java.setPrice(67);
		java.setTitle("Java Fundamentals");
		java.setReference(true);

		Socket connection = null;
		ObjectInputStream ois = null;
		ObjectOutputStream oos = null;
		PDU request = null;
		PDU response = null;

		connection = new Socket("localhost", 1234);
		oos = new ObjectOutputStream(connection.getOutputStream());
		request = new PDU();
		request.setHeader(Protocol.REQ_ADD);
		request.setPayload(xml);
		oos.writeObject(request);
		ois = new ObjectInputStream(connection.getInputStream());
		response = (PDU) ois.readObject();
		if (response.getHeader() != Protocol.RESP_ADD)
			((LibraryException) response.getPayload()).printStackTrace();
		oos.close();
		ois.close();
		connection.close();

		connection = new Socket("localhost", 1234);
		oos = new ObjectOutputStream(connection.getOutputStream());
		request = new PDU();
		request.setHeader(Protocol.REQ_ADD);
		request.setPayload(java);
		oos.writeObject(request);
		ois = new ObjectInputStream(connection.getInputStream());
		response = (PDU) ois.readObject();
		if (response.getHeader() != Protocol.RESP_ADD)
			((LibraryException) response.getPayload()).printStackTrace();
		oos.close();
		ois.close();
		connection.close();

		connection = new Socket("localhost", 1234);
		oos = new ObjectOutputStream(connection.getOutputStream());
		request = new PDU();
		request.setHeader(Protocol.REQ_SEARCH);
		request.setPayload(12345);
		oos.writeObject(request);
		ois = new ObjectInputStream(connection.getInputStream());
		response = (PDU) ois.readObject();
		if (response.getHeader() != Protocol.RESP_SEARCH)
			((LibraryException) response.getPayload()).printStackTrace();
		else
			System.out.println(response.getPayload());
		oos.close();
		ois.close();
		connection.close();

		connection = new Socket("localhost", 1234);
		oos = new ObjectOutputStream(connection.getOutputStream());
		request = new PDU();
		request.setHeader(Protocol.REQ_SEARCH);
		request.setPayload(23456);
		oos.writeObject(request);
		ois = new ObjectInputStream(connection.getInputStream());
		response = (PDU) ois.readObject();
		if (response.getHeader() != Protocol.RESP_SEARCH)
			((LibraryException) response.getPayload()).printStackTrace();
		else
			System.out.println(response.getPayload());
		oos.close();
		ois.close();
		connection.close();
	}
}