package com.glarimy.jws;

import java.util.HashMap;
import java.util.Map;

public class PublicLibrary implements Library {
	private Map<Integer, Book> books;

	public PublicLibrary() {
		books = new HashMap<Integer, Book>();
	}

	@Override
	public void add(Book book) throws LibraryException {
		books.put(book.getIsbn(), book);
	}

	@Override
	public Book search(int isbn) throws LibraryException {
		Book book = books.get(isbn);
		if (book != null)
			return book;
		throw new LibraryException("No book found with ISBN: " + isbn);
	}

}
