package com.glarimy.jws;

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;

public class Server {
	public static void main(String[] args) throws Exception {
		ServerSocket server = new ServerSocket(1234);
		Library library = new PublicLibrary();
		ObjectOutputStream oos = null;
		ObjectInputStream ois = null;
		PDU request = null;
		PDU response = null;
		while (true) {
			Socket client = server.accept();
			ois = new ObjectInputStream(client.getInputStream());
			request = (PDU) ois.readObject();
			response = new PDU();
			switch (request.getHeader()) {
			case Protocol.REQ_ADD:
				Book book = (Book) request.getPayload();
				try {
					library.add(book);
					response.setHeader(Protocol.RESP_ADD);
				} catch (LibraryException e) {
					response.setHeader(Protocol.ERROR);
					response.setPayload(e);
				}
				break;
			case Protocol.REQ_SEARCH:
				int isbn = (Integer) request.getPayload();
				try {
					Book result = library.search(isbn);
					response.setHeader(Protocol.RESP_SEARCH);
					response.setPayload(result);
				} catch (LibraryException e) {
					response.setHeader(Protocol.ERROR);
					response.setPayload(e);
				}
				break;
			default:
				response.setHeader(Protocol.ERROR);
			}
			oos = new ObjectOutputStream(client.getOutputStream());
			oos.writeObject(response);
		}
	}
}